# Higgins v0.95 
# Intelligent Vocabulary Quiz 
# to help you with your self-study of a foreign language
# 
# Copyright (C) 2004-2005 Martijn van Iersel 
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#

#################
###  nounobj  ###
#################

package NounObj;

use strict;
use warnings;

    sub new { #question, answer

        my($class)  = shift;
        my($question) = shift;
        my($answer) = shift;
        my($dir) = shift;
        my($self)   = { };                           

	# how many times should this be answered correct before moving to the
	# next box?
        $self->{left} = 1;
	# what box are we in?
	$self->{box} = 1;
	# if we made a mistake, repeat after a couple of questions
	# -1 == no mistake made, no repeating necessary
	$self->{howSoon} = -1;
	# how many times was this question asked?
	$self->{quizCount} = 0;
	# how many times was it answered correctly?
	$self->{correctCount} = 0;
	$self->{question} = $question;
        $self->{answer} = $answer;
        $self->{wronganswers} = ();
        $self->{dir} = $dir;        
        return(bless($self, $class));

    }

    sub compareAnswer { # answer
        my ($self) = shift;
        my ($answer) = shift;
        my ($counter) = shift;
        my $return = 0;
	$self->{quizCount} += 1;	

        if ($answer eq $self->{answer})
        {
            #correct
            $self->{correctCount}++;
	    $self->{left} -= 1;
	    if ($self->{left} == 0)
	    {
		    $self->{box} += 1;
		    $self->{howSoon} = -1;
		    $self->{left} = 1;
	    }	    
	    else
	    {
	           $self->{howSoon} = $counter;
	    }
            $return = 1;
        }
        else
        {
            #wrong
            $self->{left} = 2;
            $self->{howSoon} = $counter; 
            push @${$self->{wronganswer}}, $answer; # store wrong answers           
        }
        $counter++;

        return $return;
    }

1;
